
using System;

namespace ODE.Integrators
{
	
	/// <summary>
	/// Regular forwards Euler integrator 
	/// </summary>
	public class EulerIntegrator : IntegratorBase
	{
		
		public EulerIntegrator()
		{
		}
		
		public override void Update(DerivativesDelegate derivatives) {
			
			double[] dydx;
			
			// get derivatives
			derivatives(x, y, out dydx);
			
			for (int i = 0; i < n; i++) {
				// apply forward Euler method
				y[i] = y[i] + h*dydx[i];
			}
			
			x += h;
		}
	}
}
